# UnsafeArrays.jl

[![License](http://img.shields.io/badge/license-MIT-brightgreen.svg?style=flat)](LICENSE.md)
[![Build Status](https://github.com/JuliaArrays/UnsafeArrays.jl/workflows/CI/badge.svg?branch=main)](https://github.com/JuliaArrays/UnsafeArrays.jl/actions?query=workflow%3ACI)
[![Codecov](https://codecov.io/gh/JuliaArrays/UnsafeArrays.jl/branch/main/graph/badge.svg)](https://codecov.io/gh/JuliaArrays/UnsafeArrays.jl)

UnsafeArrays provides stack-allocated pointer-based array views for Julia.

This package is mainly intended as a workaround for
[Julia issue #14955 (non-allocating array views)](https://github.com/JuliaLang/julia/issues/14955). This issue is solved in Julia v1.5 and higher.

In Julia versions 1.4 and below, the Julia compiler is sometimes able to
elide heap-allocation of views in some, but cannot always do so. If the view
can't be elided, the relative cost of allocation and garbage collection of a
views is usually still small, in single-threaded applications. But in
in multi-threaded applications that use a large number of views, this cost can
quickly become prohibitive and views must either be avoided (resulting in more
lengthy and less readable code), or some form stack-allocated views must be
used for decent scalability. UnsafeArrays provides such a solution.
With Julia v1.5 and higher, using UnsafeArrays should not be necessary and is
not likely to result in significant performance gains.

Starting with v1.5, Julia can allocate immutable objects that contain
heap references on the stack, making UnsafeArrays.jl largely unnecessary.
It may still be useful as a lightweight wrapper for memory allocated outside
of Julia's memory management.

Example:

```julia
using Base.Threads, LinearAlgebra

function colnorms!(dest::AbstractVector, A::AbstractMatrix)
    @threads for i in axes(A, 2)
        dest[i] = norm(view(A, :, i))
    end
    dest
end

A = rand(50, 100000);
dest = similar(A, size(A, 2));

colnorms!(dest, A)
```

The above will run fine on a single thread, but scales badly on multiple
threads. Use the `@uviews` macro provided by UnsafeArrays to replace A with an
`UnsafeArray` within the scope of the macro. An `UnsafeArray` is
stack-allocated, and so are all views of it, e.g. within `colnorms!`:

```julia
using UnsafeArrays

@uviews A begin
    colnorms!(dest, A)
end
```

`@uviews` protects the original array `A` from GC, so the above is safe as
long as the original array is not reallocated (via `resize!`, etc.) while the
scope of `@uviews` is active.

UnsafeArrays only supports bits types. If the element type of an array is not
compatible, @uviews will simply use the original array.

UnsafeArrays also provides:

* A non macro-variant `uviews()`

* A function `uview()` to directly get an unsafe view (with optional
  sub-indexing) of an array.

* The type `UnsafeArray` itself, instances can be constructed from a data
  pointer and array size. The data type must be a bits type.

When using `uview()` and `UnsafeArray` directly, the user is responsible for
preserving the memory accessed from garbage collection.

# This file is a part of UnsafeArrays.jl, licensed under the MIT License (MIT).


"""
    uview(A::AbstractArray, I...)

Unsafe equivalent of `view`. May return an `UnsafeArray`, a standard
`SubArray` or `A` itself, depending on `I...` and the type of `A`.

As `uview` may return an `UnsafeArray`, `A` itself and it's contents *must* be
protected from garbage collection (e.g. via `GC.@preserve` on Julia > v0.6)
and memory reallocation while the view is in use.

Use `uviews(f::Function, As::AbstractArray...)` or `@uviews A ... expr` to
use unsafe views of one or multiple arrays with automatically GC protection.

```
uviews(A, B, ...) do (A_u, B_u, ...)
    # Do something with the unsafe views A_u, B_u, ...
    # Code here must not resize/append/etc. A, B, ...
end
```

To provide support for `uview` for custom array types, add methods to
function `UnsafeArrays.unsafe_uview`.
"""
function uview end
export uview

Base.@propagate_inbounds uview(A::AbstractArray) = unsafe_uview(A)

Base.@propagate_inbounds function uview(A::AbstractArray, idx, I...)
    J = Base.to_indices(A, (idx, I...))
    @boundscheck checkbounds(A, J...)
    unsafe_uview(A, J...)
end


Base.@propagate_inbounds uview(A::UnsafeArray) = A


"""
    UnsafeArray.unsafe_uview(A::AbstractArray, I::Vararg{Base.ViewIndex,N})
    UnsafeArray.unsafe_uview(A::AbstractArray, i::Base.ViewIndex)
    UnsafeArray.unsafe_uview(A::AbstractArray)

To support `uview` for custom array types, add methods to `unsafe_uview`
instead of `uview`. Implementing
`UnsafeArray.unsafe_uview(A::CustomArrayType)` will often be sufficient.

It may be necessary to provide a custom implementation of `Base.deepcopy`
for types with a custom implementation of `unsafe_uview`, to ensure that
the result of `deepcopy` does *NOT* contain unsafe views.
"""
function unsafe_uview end

Base.@propagate_inbounds unsafe_uview(A::AbstractArray{T,N}, I::Vararg{Base.ViewIndex,N}) where {T,N} =
    Base.unsafe_view(unsafe_uview(A), I...)

Base.@propagate_inbounds unsafe_uview(A::AbstractArray{T,N}, i) where {T,N} =
    Base.unsafe_view(unsafe_uview(A), i::Base.ViewIndex)

Base.@propagate_inbounds unsafe_uview(A::AbstractArray{T,N}) where {T,N} = A

Base.@propagate_inbounds unsafe_uview(A::UnsafeArray{T,N}) where {T,N} = A


Base.@propagate_inbounds unsafe_uview(A::DenseArray{T,N}) where {T,N} =
    _maybe_unsafe_uview(Val{isbitstype(T)}(), A)

Base.@propagate_inbounds unsafe_uview(A::SubArray{T,N}) where {T,N} =
    _maybe_unsafe_uview(Val{isbitstype(T) && Base.iscontiguous(typeof(A))}(), A)

Base.@propagate_inbounds function _maybe_unsafe_uview(unsafe_compatible::Val{true}, A::AbstractArray{T,N}) where {T,N}
    @boundscheck _require_one_based_indexing(A)
    UnsafeArray{T,N}(unsafe_compatible, pointer(A), size(A))
end

Base.@propagate_inbounds _maybe_unsafe_uview(unsafe_compatible::Val{false}, A::AbstractArray{T,N}) where {T,N} = A


"""
    uviews(f::Function, As::AbstractArray...)

Equivalent to `f(map(uview, As)...)`. Automatically protects the array(s)
`As` from garbage collection during execution of `f`.

Example:

```
uviews(A, B, ...) do (A_u, B_u, ...)
    # Do something with the unsafe views A_u, B_u, ...
    # Code here must not resize/append/etc. A, B, ...
end
```

In many cases, it may be preferable to use `@uviews` insted of `views`.
"""
function uviews end
export uviews

@inline function uviews(f::Function, As::AbstractArray...)
    GC.@preserve(As, f(map(uview, As)...))
end


"""
    @uviews A B ... expr

Replace arrays `A`, `B`, ... by uview(`A`), uview(`B`), ... during execution
of `expr`, while protecting the original arrays from garbage collection.

Equivalent to

```
GC.@preserve A B ... begin
    let A = uview(A), B = uview(B), ...
        expr
    end
end
```

The unsafe views must not be allowed to escape the scope of `expr`. The
original arrays must not be resized/appended/etc. during the execution of
`expr`.
"""
macro uviews(args...)
    syms = args[1:end-1]
    expr = args[end]

    binds = Expr(:block)
    for s in syms
        s isa Symbol || error("@uviews targets must be a symbols")
        push!(binds.args, :($s = $UnsafeArrays.uview($s)))
    end
    let_expr = Expr(:let, binds, expr)
    esc(:(GC.@preserve $(syms...) $(let_expr)))
end

export @uviews


function Base.mightalias(A::UnsafeArray, B::UnsafeArray)
    pfA = pointer(A, firstindex(A))
    plA = pointer(A, lastindex(A))
    pfB = pointer(B, firstindex(B))
    plB = pointer(B, lastindex(B))

    (pfA <= pfB <= plA) || (pfA <= plB <= plA) || (pfB <= pfA <= plB)
end

function Base.mightalias(A::UnsafeArray, B::AbstractArray)
    @uviews B begin
        if typeof(B) <: UnsafeArray
            Base.mightalias(A, B)
        else
            # Don't know if A and B might alias:
            false
        end
    end
end

Base.mightalias(A::AbstractArray, B::UnsafeArray) = Base.mightalias(B, A)

# Need to specialize mightalias SubArrays of UnsafeArrays since the
# default mightalias implementation returns false for all isbits types:

Base.mightalias(A::SubArray{T,N,<:UnsafeArray}, B::AbstractArray) where {T,N} =
    Base.mightalias(parent(A), B)

Base.mightalias(A::SubArray{T,N,<:UnsafeArray}, B::SubArray) where {T,N} =
    Base.mightalias(parent(A), B)

Base.mightalias(A::SubArray{T1,N1,<:UnsafeArray}, B::SubArray{T2,N2,<:UnsafeArray}) where {T1,N1,T2,N2} =
    Base.mightalias(parent(A), parent(B))

Base.mightalias(A::SubArray{T,N,<:UnsafeArray}, B::UnsafeArray) where {T,N} =
    Base.mightalias(parent(A), B)

Base.mightalias(A::AbstractArray, B::SubArray{T,N,<:UnsafeArray}) where {T,N} =
    Base.mightalias(B, A)

Base.mightalias(A::SubArray, B::SubArray{T,N,<:UnsafeArray}) where {T,N} =
    Base.mightalias(B, A)

Base.mightalias(A::UnsafeArray, B::SubArray{T,N,<:UnsafeArray}) where {T,N} =
    Base.mightalias(B, A)

# This file is a part of UnsafeArrays.jl, licensed under the MIT License (MIT).

using UnsafeArrays
using Test

using Random


@testset "unsafe_array" begin
    function rand_array(::Type{T}, Val_N::Val{N}) where {T, N}
        sz_max = (8, 7, 5, 4, 5)
        sz = ntuple(i -> sz_max[i], Val_N)
        rand!(Array{T}(undef, sz...))
    end


    function rand_array(::Type{T}, Val_N::Val{N}) where {T<:Integer, N}
        sz_max = (8, 7, 5, 4, 5)
        sz = ntuple(i -> sz_max[i], Val_N)
        rand!(Array{T}(undef, sz...), 0:99)
    end


    function test_A(test_code::Function, ::Type{T}, Val_N::Val{N}) where {T, N}
        A = rand_array(T, Val_N)
        UnsafeArrays.@gc_preserve A test_code(A)
    end


    function test_A_UA(test_code::Function, ::Type{T}, Val_N::Val{N}) where {T, N}
        A = rand_array(T, Val_N)
        UA = UnsafeArray(pointer(A), size(A))
        UnsafeArrays.@gc_preserve A test_code(A, UA)
    end


    function test_empty_A_UA(test_code::Function, ::Type{T}, Val_N::Val{N}) where {T, N}
        A = rand(T, 0, fill(4, N-1)...)
        UA = UnsafeArray(pointer(A), size(A))
        UnsafeArrays.@gc_preserve A test_code(A, UA)
    end


    @testset "ctors" begin
        test_A(Float64, Val(0)) do A
            ptr = pointer(A)
            sz = size(A)
            @test typeof(@inferred(UnsafeArray{Float64,0}(Val(true), ptr, sz))) == UnsafeArray{Float64,0}
            @test typeof(@inferred(UnsafeArray{Float64,0}(ptr, sz))) == UnsafeArray{Float64,0}
            @test typeof(@inferred(UnsafeArray(ptr, sz))) == UnsafeArray{Float64,0}
            @test_throws MethodError typeof(UnsafeArray{Float64,0}(Val(false), ptr, sz))
        end

        test_A(Int, Val(2)) do A
            ptr = pointer(A)
            sz = size(A)
            @test typeof(@inferred(UnsafeArray{Int,2}(Val(true), ptr, sz))) == UnsafeArray{Int,2}
            @test typeof(@inferred(UnsafeArray{Int,2}(ptr, sz))) == UnsafeArray{Int,2}
            @test typeof(@inferred(UnsafeArray(ptr, sz))) == UnsafeArray{Int,2}
            @test_throws MethodError typeof(UnsafeArray{Int,2}(Val(false), ptr, sz))
        end
    end


    @testset "size, length, index style, etc." begin
        run_test(T::Type, Val_N::Val) = test_A_UA(T, Val_N) do A, UA
            T = eltype(UA)
            @test @inferred(length(UA)) == length(A)
            @test @inferred(IndexStyle(UA)) == IndexLinear()
            @test @inferred(IndexStyle(typeof(UA))) == IndexLinear()
            @test @inferred(LinearIndices(UA)) == LinearIndices(A)
            @test @inferred(eachindex(UA)) == eachindex(A)

            @test @inferred(Base.unsafe_convert(Ptr{T}, UA)) == Base.unsafe_convert(Ptr{T}, A)
            @test @inferred(pointer(UA)) == pointer(A)

            @test @inferred(Base.iscontiguous(UA)) == true
            @test @inferred(Base.iscontiguous(typeof(UA))) == true
        end

        run_test(Int, Val(0))
        run_test(Float64, Val(2))
    end


    @testset "equality, getindex and setindex!" begin
        test_A_UA(Float32, Val(2)) do A, UA
            test_A_UA(Float32, Val(2)) do B, UB
                @test UA != UB
                A .= B
                @test UA == UB
            end
        end

        test_A_UA(Float32, Val(2)) do A, UA
            B = rand_array(Float32, Val(2))
            rand!(B)
            for i in eachindex(UA, B)
                UA[i] = B[i]
            end
            @test A == B
            @test UA == B
            @test all(i -> UA[i] == B[i], eachindex(UA, B))
            @test all(i -> UA[i] == B[i], CartesianIndices(size(UA)))
        end

        test_A_UA(Int, Val(1)) do A, UA
            @test all(x -> x == 42, @inferred fill!(UA, 42))
        end
    end


    @testset "view" begin
        test_A_UA(Int16, Val(0)) do A, UA
            @test view(UA) === UA
            @test view(UA) == view(A)
        end

        test_A_UA(Int, Val(1)) do A, UA
            @test typeof(@inferred(view(UA, :))) == UnsafeArray{Int,1}
            @test typeof(@inferred(view(UA, 2:4))) == UnsafeArray{Int,1}
            @test typeof(@inferred(view(UA, 2))) == UnsafeArray{Int,0}

            @test view(UA, :) == view(A, :)
            @test view(UA, 2:4) == view(A, 2:4)
            @test view(UA, 2) == view(A, 2)

            @test isbits(view(UA, :)) == true
            @test isbits(view(UA, 2:4)) == true
            @test isbits(view(UA, 2)) == true
        end

        test_A_UA(Float32, Val(3)) do A, UA
            @test typeof(@inferred(view(UA, :))) == UnsafeArray{Float32,1}
            @test typeof(@inferred(view(UA, :, :, :))) == UnsafeArray{Float32,3}
            # TODO: Type inference fails for some reason:
            # @test typeof(@inferred(view(UA, :, 3, :))) <: SubArray
            @test typeof((view(UA, :, 3, :))) <: SubArray
            @test typeof(@inferred(view(UA, :, :, 3))) == UnsafeArray{Float32,2}
            @test typeof(@inferred(view(UA, :, 2:4, 3))) == UnsafeArray{Float32,2}
            @test typeof(@inferred(view(UA, :, 2, 3))) == UnsafeArray{Float32,1}
            @test typeof(@inferred(view(UA, 2, 2, 3))) == UnsafeArray{Float32,0}
            @test_throws BoundsError view(UA, 2, 2:20, 3)

            @test view(UA, :) == view(A, :)
            @test view(UA, :, :, :) == view(A, :, :, :)
            @test view(UA, :, 3, :) == view(A, :, 3, :)
            @test view(UA, :, :, 3) == view(A, :, :, 3)
            @test view(UA, :, 2:4, 3) == view(A, :, 2:4, 3)
            @test view(UA, :, 2, 3) == view(A, :, 2, 3)
            @test view(UA, 2, 2, 3) == view(A, 2, 2, 3)

            @test isbits(view(UA, :)) == true
            @test isbits(view(UA, :, :, :)) == true
            @test isbits(view(UA, :, 3, :)) == true
        end

        test_empty_A_UA(Float32, Val(2)) do A, UA
            @test @inferred(view(UA, :, 2:3)) isa UnsafeArray
            @test size(@inferred(view(UA, :, 2:3))) == (0, 2)
        end
    end


    @testset "reshape" begin
        test_A_UA(Float32, Val(3)) do A, UA
            @test typeof(@inferred(reshape(UA, size(UA, 1), size(UA, 2) * size(UA, 3)))) == UnsafeArray{Float32, 2}
            @test typeof(@inferred(reshape(UA, size(UA, 1) * size(UA, 2) * size(UA, 3)))) == UnsafeArray{Float32, 1}

            @test reshape(UA, size(UA, 1), size(UA, 2) * size(UA, 3)) == reshape(A, size(A, 1), size(A, 2) * size(A, 3))
            @test reshape(UA, size(UA, 1) * size(UA, 2) * size(UA, 3)) == reshape(A, size(A, 1) * size(A, 2) * size(A, 3))
        end

        test_A_UA(Int, Val(1)) do A, UA
            @test typeof(@inferred(reshape(UA, 2, div(size(UA, 1), 2)))) == UnsafeArray{Int, 2}
            @test reshape(UA, 2, div(size(UA, 1), 2)) == reshape(A, 2, div(size(A, 1), 2))
        end
    end


    @testset "copyto! and conversion" begin
        test_A_UA(Int32, Val(3)) do A, UA
            B = similar(A, Int32)
            @test B === @inferred(copyto!(B, UA))
            @test B == A
        end

        test_A_UA(Int32, Val(3)) do A, UA
            B = similar(A, Int64)
            @test B === @inferred(copyto!(B, UA))
            @test B == A
        end

        test_A_UA(Int32, Val(3)) do A, UA
            B = zeros(Int32, size(A)...)
            @test B === @inferred(copyto!(B, 3, UA, 5, 7))
            C = zeros(Int32, size(A)...)
            copyto!(C, 3, A, 5, 7)
            @test B == C
        end

        test_A_UA(Int32, Val(3)) do A, UA
            B = zeros(Int64, size(A)...)
            @test B === @inferred(copyto!(B, 3, UA, 5, 7))
            C = zeros(Int64, size(A)...)
            copyto!(C, 3, A, 5, 7)
            @test B == C
        end

        test_A_UA(Int32, Val(1)) do A, UA
            B = zeros(Int32, size(A)...)
            @test B === @inferred(copyto!(B, 2, UA, 3, 4))
            C = zeros(Int32, size(A)...)
            copyto!(C, 2, A, 3, 4)
            @test B == C
            @test_throws BoundsError copyto!(B, 3, UA, 5, 7)
        end

        test_A_UA(Int32, Val(1)) do A, UA
            B = zeros(Int64, size(A)...)
            @test B === @inferred(copyto!(B, 2, UA, 3, 4))
            C = zeros(Int32, size(A)...)
            copyto!(C, 2, A, 3, 4)
            @test B == C
            @test_throws BoundsError copyto!(B, 3, UA, 5, 7)
        end


        test_A_UA(Float64, Val(3)) do A, UA
            B = rand(Float64, size(A)...)
            A2 = deepcopy(A)
            copyto!(A2, B)
            @test UA === @inferred(copyto!(UA, B))
            @test UA == A2
        end

        test_A_UA(Float64, Val(3)) do A, UA
            B = rand(Float32, size(A)...)
            A2 = deepcopy(A)
            copyto!(A2, B)
            @test UA === @inferred(copyto!(UA, B))
            @test UA == A2
        end

        test_A_UA(Float64, Val(3)) do A, UA
            B = rand(Float64, size(A)...)
            A2 = deepcopy(A)
            copyto!(A2, 3, B, 5, 7)
            @test UA === @inferred(copyto!(UA, 3, B, 5, 7))
            @test UA == A2
        end

        test_A_UA(Float64, Val(3)) do A, UA
            B = rand(Float32, size(A)...)
            A2 = deepcopy(A)
            copyto!(A2, 3, B, 5, 7)
            @test UA === @inferred(copyto!(UA, 3, B, 5, 7))
            @test UA == A2
        end

        test_A_UA(Float64, Val(1)) do A, UA
            B = rand(Float64, size(A)...)
            A2 = deepcopy(A)
            copyto!(A2, 2, B, 3, 4)
            @test UA === @inferred(copyto!(UA, 2, B, 3, 4))
            @test UA == A2
            @test_throws BoundsError copyto!(UA, 3, B, 5, 7)
        end

        test_A_UA(Float64, Val(1)) do A, UA
            B = rand(Float32, size(A)...)
            A2 = deepcopy(A)
            copyto!(A2, 2, B, 3, 4)
            @test UA === @inferred(copyto!(UA, 2, B, 3, 4))
            @test UA == A2
            @test_throws BoundsError copyto!(UA, 3, B, 5, 7)
       end
    end


    @testset "deepcopy" begin
        test_A_UA(Float32, Val(3)) do A, UA
            @test typeof(@inferred(deepcopy(UA))) == typeof(A)
            @test deepcopy(UA) == A
        end

        test_A_UA(Int16, Val(1)) do A, UA
            @test typeof(@inferred(deepcopy(UA))) == typeof(A)
            @test deepcopy(UA) == A
        end
    end


    # # Disabled, as specialization of Base.unaliascopy is disabled:
    #
    # @testset "unaliascopy" begin
    #     test_A_UA(Float32, Val(3)) do A, UA
    #         @test typeof(@inferred(Base.unaliascopy(UA))) == typeof(A)
    #         @test Base.unaliascopy(UA) == A
    #     end
    #
    #     test_A_UA(Int16, Val(1)) do A, UA
    #         @test typeof(@inferred(Base.unaliascopy(UA))) == typeof(A)
    #         @test Base.unaliascopy(UA) == A
    #     end
    # end


    @testset "conversion" begin
        test_A_UA(Float32, Val(3)) do A, UA
            @test typeof(@inferred(convert(Array, UA))) == typeof(A)
            @test convert(Array, UA) == A
        end

        test_A_UA(Int16, Val(1)) do A, UA
            @test typeof(@inferred(convert(Array, UA))) == typeof(A)
            @test convert(Array, UA) == A
        end
    end

    @testset "reinterpret" begin
        test_A_UA(Float32, Val(3)) do A, UA
            @test reinterpret(UInt32, UA) == reinterpret(UInt32, A)
            @test reinterpret(UInt8, UA) == reinterpret(UInt8, A)

            if VERSION >= v"1.6" # reinterpret(reshape, ...) requires at least Julia 1.6
                @test reinterpret(reshape, UInt8, UA) == reinterpret(reshape, UInt8, A)
                @test reinterpret(reshape, UInt32, UA) == reinterpret(reshape, UInt32, A)
                @test reinterpret(reshape, NTuple{8, Float32}, UA) == reinterpret(reshape, NTuple{8, Float32}, A)
            else # testing the alternative
                @test reinterpret(reshape, UInt8, UA) == reshape(reinterpret(UInt8, A), (4, 8, 7, 5))
                @test reinterpret(reshape, UInt32, UA) == reinterpret(UInt32, A)
                @test reinterpret(reshape, NTuple{8, Float32}, UA) == reshape(reinterpret(NTuple{8, Float32}, A), (7, 5))
            end

            @test_throws ArgumentError reinterpret(reshape, NTuple{5, Float32}, UA)
            @test_throws ArgumentError reinterpret(reshape, Nothing, UA)
            @test_throws ArgumentError reinterpret(reshape, NTuple{3, UInt8}, UA)
        end

        # NOTE: this requires sz_max[1] to be divisible by 4
        test_A_UA(UInt8, Val(3)) do A, UA
            @test reinterpret(UInt32, UA) == reinterpret(UInt32, A)
            @test reinterpret(Int8, UA) == reinterpret(Int8, A)
        end

        A = UInt32[ 1, 2, 3 ]
        UA = UnsafeArray(pointer(A), size(A))
        @test_throws ArgumentError reinterpret(UInt64, UA)
    end
end

# This file is a part of UnsafeArrays.jl, licensed under the MIT License (MIT).

using UnsafeArrays
using Test


@testset "util" begin
    @testset "_sub_axes" begin
        @test @inferred(UnsafeArrays._sub_axes()) == ()
        @test @inferred(UnsafeArrays._sub_axes(1)) == ()
        @test @inferred(UnsafeArrays._sub_axes(2:5)) == (Base.OneTo(4),)
        @test @inferred(UnsafeArrays._sub_axes(Base.OneTo(5))) == (Base.OneTo(5),)
        @test @inferred(UnsafeArrays._sub_axes(4, 5, 6)) == ()
        @test @inferred(UnsafeArrays._sub_axes(1:4, 5, 6)) == (Base.OneTo(4),)
        @test @inferred(UnsafeArrays._sub_axes(1:4, 1:5, 6)) == (Base.OneTo(4), Base.OneTo(5))
        @test @inferred(UnsafeArrays._sub_axes(1:4, 1:5, 1:6)) == (Base.OneTo(4), Base.OneTo(5), Base.OneTo(6))
        @test @inferred(UnsafeArrays._sub_axes(1:4, 3, 1:6)) == (Base.OneTo(4), Base.OneTo(6))
        @test @inferred(UnsafeArrays._sub_axes(2, 1:5, 1:6)) == (Base.OneTo(5), Base.OneTo(6))
    end


    @testset "_sub_size" begin
        @test @inferred(UnsafeArrays._sub_size()) == ()
        @test @inferred(UnsafeArrays._sub_size(1)) == ()
        @test @inferred(UnsafeArrays._sub_size(2:5)) == (4,)
        @test @inferred(UnsafeArrays._sub_size(Base.OneTo(5))) == (5,)
        @test @inferred(UnsafeArrays._sub_size(4, 5, 6)) == ()
        @test @inferred(UnsafeArrays._sub_size(1:4, 5, 6)) == (4,)
        @test @inferred(UnsafeArrays._sub_size(1:4, 1:5, 6)) == (4, 5)
        @test @inferred(UnsafeArrays._sub_size(1:4, 1:5, 1:6)) == (4, 5, 6)
        @test @inferred(UnsafeArrays._sub_size(1:4, 3, 1:6)) == (4, 6)
        @test @inferred(UnsafeArrays._sub_size(2, 1:5, 1:6)) == (5, 6)
    end


    @testset "_require_one_based_indexing" begin
        @test @inferred(UnsafeArrays._require_one_based_indexing(rand(3, 5))) == nothing
        @test @inferred(UnsafeArrays._require_one_based_indexing(view(rand(3, 5), 2:3, 3:4))) == nothing
    end


    @testset "_noinline_nop" begin
        @test @inferred(UnsafeArrays._noinline_nop(())) == nothing
        @test @inferred(UnsafeArrays._noinline_nop((rand(3),))) == nothing
        @test @inferred(UnsafeArrays._noinline_nop((rand(3), rand(3, 5)))) == nothing
    end


    @testset "@gc_preserve" begin
        A = rand(4, 5)
        s = "foo"
        @test (UnsafeArrays.@gc_preserve 42) == 42
        @test (UnsafeArrays.@gc_preserve A size(A)) == (4, 5)
        @test (UnsafeArrays.@gc_preserve A s (size(A), s)) == ((4, 5), "foo")
    end
end

# This file is a part of UnsafeArrays.jl, licensed under the MIT License (MIT).

__precompile__(true)

module UnsafeArrays

include("util.jl")
include("unsafe_array.jl")
include("uview.jl")

end # module

# This file is a part of UnsafeArrays.jl, licensed under the MIT License (MIT).

using Base: @propagate_inbounds
using Base.MultiplicativeInverses: SignedMultiplicativeInverse


"""
    UnsafeArray{T,N} <: DenseArray{T,N}

An `UnsafeArray` is an bitstype wrapper around a memory pointer and a
size tuple. It's an intended to be used as a short-lived, allocation-free
alternative to an an `Array` returned by `unsafe_wrap` or a `SubArray`
returned by `view` or . Use with caution!

Constructors:

    UnsafeArray{T,N}(pointer::Ptr{T}, size::NTuple{N,Int}) where {T,N}
    UnsafeArray(pointer::Ptr{T}, size::NTuple{N,Int}) where {T,N}

UnsafeArray requires `isbitstype(T) == true`.

Note: It's safe to construct an empty multidimensional `UnsafeArray`:

    UnsafeArray(Ptr{Int}(0), (0,...))

Note: You *must* ensure that `A` is not garbage collected or reallocated
via (e.g.) `resize!`, `sizehint!` etc. while `U` is in use! Use only in
situations where you have full control over the life cycle of `A` and `U`.

`deepcopy(::UnsafeArray)` returns a standard `Array`.
"""
struct UnsafeArray{T,N} <: DenseArray{T,N}
    pointer::Ptr{T}
    size::NTuple{N,Int}

    UnsafeArray{T,N}(isbits_T::Val{true}, pointer::Ptr{T}, size::NTuple{N,Int}) where {T,N} =
        new{T,N}(pointer, size)
end

export UnsafeArray

UnsafeArray{T,N}(pointer::Ptr{T}, size::NTuple{N,Int}) where {T,N} =
    UnsafeArray{T,N}(Val{isbitstype(T)}(), pointer, size)

UnsafeArray(pointer::Ptr{T}, size::NTuple{N,Int}) where {T,N} =
    UnsafeArray{T,N}(pointer, size)


Base.size(A::UnsafeArray) = A.size

Base.elsize(::Type{UnsafeArray{T, N}}) where {T, N} = sizeof(T)

@inline function Base.getindex(A::UnsafeArray, i::Integer)
    @boundscheck checkbounds(A, i)
    unsafe_load(A.pointer, i)
end

@inline function Base.setindex!(A::UnsafeArray, x, i::Integer)
    @boundscheck checkbounds(A, i)
    unsafe_store!(A.pointer, x, i)
end

@inline Base.IndexStyle(A::UnsafeArray) = IndexLinear()

Base.unsafe_convert(::Type{Ptr{T}}, A::UnsafeArray{T}) where T = A.pointer

Base.iscontiguous(::UnsafeArray) = true
Base.iscontiguous(::Type{<:UnsafeArray}) = true


Base.@propagate_inbounds Base.unsafe_view(A::UnsafeArray{T,N}, I::Vararg{Base.ViewIndex,N}) where {T,N} =
    _unsafe_view_impl((), A, I...)

Base.@propagate_inbounds Base.unsafe_view(A::UnsafeArray{T,N}, i::Base.ViewIndex) where {T,N} =
    _unsafe_view_impl((), A, i)


@inline function _unsafe_view_impl(IFwd::NTuple{N,Base.Slice}, A::UnsafeArray{T,N}) where {T,N}
    @assert IFwd == axes(A)
    A
end

Base.@propagate_inbounds _unsafe_view_impl(IFwd::NTuple{N,Base.ViewIndex}, A::UnsafeArray{T,N}) where {T,N} =
    SubArray(A, IFwd)

Base.@propagate_inbounds _unsafe_view_impl(IFwd::NTuple{M,Base.ViewIndex}, A::UnsafeArray{T,N}, i::Base.ViewIndex, I::Base.ViewIndex...) where {T,M,N} =
    _unsafe_view_impl((IFwd..., i), A, I...)

@inline function _unsafe_view_impl(IFwd::NTuple{M,Base.Slice}, A::UnsafeArray{T,N}, i::DenseIdx, I::Integer...) where {T,M,N}
    ax_A = axes(A)
    @assert IFwd == ntuple(i -> axes(A)[i], Val{M}())
    I_all = (IFwd..., i, I...)
    @boundscheck checkbounds(A, I_all...)
    startidxs = map(first, (IFwd..., i, I...))
    firstidxs = map(first, ax_A)
    sub_s = _sub_size(I_all...)
    A_isempty = length(A) == 0
    view_isempty = prod(sub_s) == 0
    # getindex on LinearIndices fails with startidxs if A is empty, so use pseudo-size in that case:
    sz = size(A)
    pseudo_sz = ntuple(_ -> 1, Val(N))
    mod_size, mod_startidxs = ifelse(A_isempty && view_isempty, (pseudo_sz, firstidxs), (sz, startidxs))
    p = pointer(A, LinearIndices(mod_size)[mod_startidxs...])
    UnsafeArray(p, sub_s)
end

@inline function _unsafe_view_impl(IFwd::Tuple{}, A::UnsafeArray{T,N}, i::DenseIdx) where {T,N}
    @boundscheck checkbounds(A, i)
    p = pointer(A, first(i))
    sub_s = _sub_size(i)
    UnsafeArray(p, sub_s)
end



@inline Base.__reshape(p::Tuple{UnsafeArray,IndexLinear}, dims::Dims) =
    UnsafeArray(p[1].pointer, dims)


# From Julia Base (same implementation, with slight variations):

Base.copyto!(dest::Array{T}, src::UnsafeArray{T}) where {T} = copyto!(dest, 1, src, 1, length(src))

function Base.copyto!(dest::Array{T}, doffs::Integer, src::UnsafeArray{T}, soffs::Integer, n::Integer) where {T}
    n == 0 && return dest
    n > 0 || throw(ArgumentError(string("tried to copy n=", n, " elements, but n should be nonnegative")))
    if soffs < 1 || doffs < 1 || soffs+n-1 > length(src) || doffs+n-1 > length(dest)
        throw(BoundsError())
    end
    unsafe_copyto!(dest, doffs, src, soffs, n)
end

function Base.unsafe_copyto!(dest::Array{T}, doffs::Integer, src::UnsafeArray{T}, soffs::Integer, n::Integer) where {T}
    @assert isbitstype(T)
    unsafe_copyto!(pointer(dest, doffs), pointer(src, soffs), n)
    return dest
end

Base.copyto!(dest::UnsafeArray{T}, src::Array{T}) where {T} = copyto!(dest, 1, src, 1, length(src))

function Base.copyto!(dest::UnsafeArray{T}, doffs::Integer, src::Array{T}, soffs::Integer, n::Integer) where {T}
    n == 0 && return dest
    n > 0 || throw(ArgumentError(string("tried to copy n=", n, " elements, but n should be nonnegative")))
    if soffs < 1 || doffs < 1 || soffs+n-1 > length(src) || doffs+n-1 > length(dest)
        throw(BoundsError())
    end
    unsafe_copyto!(dest, doffs, src, soffs, n)
end

function Base.unsafe_copyto!(dest::UnsafeArray{T}, doffs::Integer, src::Array{T}, soffs::Integer, n::Integer) where {T}
    @assert isbitstype(T)
    unsafe_copyto!(pointer(dest, doffs), pointer(src, soffs), n)
    return dest
end


Base.deepcopy(A::UnsafeArray) = copyto!(similar(A), A)

function Base.reinterpret(::Type{DST}, A::UnsafeArray{SRC}) where {DST, SRC}
    if sizeof(DST) != sizeof(SRC)
        sz = size(A)
        sz1, rem = divrem(sz[1] * sizeof(SRC), sizeof(DST))
        @boundscheck if rem != zero(rem)
            throw(ArgumentError("Resulting array would have non-integral first dimension"))
        end
        UnsafeArray(convert(Ptr{DST}, pointer(A)), (sz1, Base.tail(sz)...))
    else
        UnsafeArray(convert(Ptr{DST}, pointer(A)), size(A))
    end
end

# # Defining Base.unaliascopy results in very bad broadcast performance for
# # some reason, even when it shouldn't be called. By default, unaliascopy
# # results in an error for UnsafeArray.
#
# Base.unaliascopy(A::UnsafeArray) = begin
#     copy(A)
# end

# This file is a part of UnsafeArrays.jl, licensed under the MIT License (MIT).


const IdxUnitRange = AbstractUnitRange{<:Integer}
const DenseIdx = Union{IdxUnitRange,Integer}


if isdefined(Base, :checked_length)
    const unsafe_length = length
    const unsafe_indices = axes
else
    using Base: unsafe_length, unsafe_indices
end
# Similar to Base._indices_sub:
@inline _sub_axes() = ()
@inline _sub_axes(::Real, I...) = _sub_axes(I...)
@inline _sub_axes(i1::AbstractArray, I...) = (unsafe_indices(i1)..., _sub_axes(I...)...)


@inline _sub_size(sub_idxs...) = map(n->Int(unsafe_length(n)), _sub_axes(sub_idxs...))


function _require_one_based_indexing(A::AbstractArray{T,N}) where {T,N}
    typeof(axes(A)) == NTuple{N,Base.OneTo{Int}} || throw(ArgumentError("Parent array must have one-based indexing"))
    nothing
end


@noinline function _noinline_nop(x::Tuple)
    nothing
end


"""
    UnsafeArrays.@gc_preserve A B ... expr

Protect `A`, `B`, ... from garbage collection while executing `expr`. Contrary
to `GC.@preserve`, expr is executed in a new scope.

Equivalent to

```
GC.@preserve A B ... let
    expr
end
```

On Julia versions that do not provide `GC.@preserve`, a fallback
implementation is used.
"""
macro gc_preserve(args...)
    syms = args[1:end-1]
    expr = args[end]

    for s in syms
        s isa Symbol || error("@gc_preserve targets must be a symbols")
    end

    esc(:(GC.@preserve $(syms...) $(Expr(:let, Expr(:block), expr))))
end

# This file is a part of UnsafeArrays.jl, licensed under the MIT License (MIT).

using UnsafeArrays
using Test

using Random


@testset "uview" begin
    function rand_array(::Type{T}, Val_N::Val{N}) where {T, N}
        sz_max = (8, 7, 5, 4, 5)
        sz = ntuple(i -> sz_max[i], Val_N)
        rand!(Array{T}(undef, sz...))
    end

    function rand_array(::Type{T}, Val_N::Val{N}) where {T<:Integer, N}
        sz_max = (8, 7, 5, 4, 5)
        sz = ntuple(i -> sz_max[i], Val_N)
        rand!(Array{T}(undef, sz...), 0:99)
    end

    function test_A(test_code::Function, ::Type{T}, Val_N::Val{N}) where {T, N}
        A = rand_array(T, Val_N)
        UnsafeArrays.@gc_preserve A test_code(A)
    end


    @testset "uview" begin
        test_A(Float64, Val(0)) do A
            @test typeof(@inferred(uview(A))) == UnsafeArray{Float64,0}

            @test uview(A) == A
            @test uview(A) == view(A)
        end

        test_A(Float32, Val(1)) do A
            @test typeof(@inferred(uview(A))) == UnsafeArray{Float32,1}
            @test typeof(@inferred(uview(A, :))) == UnsafeArray{Float32,1}
            @test typeof(@inferred(uview(A, 2))) == UnsafeArray{Float32,0}

            @test uview(A) == A
            @test uview(A, :) == view(A, :)
            @test uview(A, 2) == view(A, 2)

            @test_throws BoundsError uview(A, 2:9)
        end

        test_A(ComplexF32, Val(3)) do A
            @test typeof(@inferred(uview(A))) == UnsafeArray{ComplexF32,3}
            @test typeof(@inferred(uview(A, :, 2:4, 3))) == UnsafeArray{ComplexF32,2}
            @test typeof(@inferred(uview(A, :))) == UnsafeArray{ComplexF32,1}
            @test typeof(@inferred(uview(A, 2, 3, 4))) == UnsafeArray{ComplexF32,0}
            # TODO: Type inference fails for some reason:
            # @test typeof(@inferred(uview(A, :, 2:4, :))) <: SubArray
            @test typeof((uview(A, :, 2:4, :))) <: SubArray

            @test uview(A) == A
            @test uview(A, :, 2:4, 3) == view(A, :, 2:4, 3)
            @test uview(A, :) == view(A, :)
            @test uview(A, 2, 3, 4) == view(A, 2, 3, 4)
            @test uview(A, :, 2:4, :) == view(A, :, 2:4, :)

            @test_throws BoundsError uview(A, :, 2:9, 3)

            B = view(A, :, :, 3)

            @test typeof(@inferred(uview(B))) == UnsafeArray{ComplexF32,2}
            @test typeof(@inferred(uview(B, :, 2:4))) == UnsafeArray{ComplexF32,2}

            @test uview(B) == B
            @test uview(B, :, 2:4) == view(B, :, 2:4)

            C = uview(A, :, :, 3)

            @test uview(C) === C
            @test typeof(@inferred(uview(C, :, 2:4))) == UnsafeArray{ComplexF32,2}
            @test uview(C, :, 2:4) == view(B, :, 2:4)
        end

        let A = ["foo", "bar", "baz"]
            UnsafeArrays.@gc_preserve A begin
                @test @inferred(uview(A)) === A
                @test typeof(@inferred(uview(A, 2:3))) <: SubArray
                @test uview(A, 2:3) == view(A, 2:3)
            end
        end
    end


    @testset "uviews" begin
        A = rand(Int32, 8)
        B = rand(ComplexF64, 3, 5, 4)

        @test uviews(() -> 42) == 42
        @test uviews(A -> typeof(A), A) == UnsafeArray{Int32, 1}
        @test uviews((A, B) -> (typeof(A), typeof(B)), A, B) == (UnsafeArray{Int32, 1}, UnsafeArray{ComplexF64, 3})
    end


    @testset "@uviews" begin
        @eval module TestMacroScope

        # Test `@uviews` macro in a new module with minimal symbols imported from `UnsafeArrays`
        using UnsafeArrays: UnsafeArray, @uviews
        using Test

        A = rand(Int32, 8)
        B = rand(ComplexF64, 3, 5, 4)

        @test @uviews(42) == 42
        @test @uviews(A, typeof(A)) == UnsafeArray{Int32, 1}
        @test @uviews(A, B, (typeof(A), typeof(B))) == (UnsafeArray{Int32, 1}, UnsafeArray{ComplexF64, 3})

        end # module TestMacroScope
    end


    @testset "Base.mightalias" begin
        A = rand(Int32, 10, 15)
        B = rand(Int32, 12, 17)
        C = ["foo", "bar", "a", "b", "c", "d", "e"]

        @uviews A B begin
            @test true == @inferred Base.mightalias(A, A)
            @test false == @inferred Base.mightalias(A, B)

            @test false == @inferred Base.mightalias(view(A, :, 2:5), view(A, :, 6:10))
            @test false == @inferred Base.mightalias(view(A, :, 6:10), view(A, :, 2:5))

            @test true == @inferred Base.mightalias(view(A, :, 2:6), view(A, :, 5:10))
            @test true == @inferred Base.mightalias(view(A, :, 5:10), view(A, :, 2:6))
            @test true == @inferred Base.mightalias(view(A, :, 2:10), view(A, :, 5:6))
            @test true == @inferred Base.mightalias(view(A, :, 5:6), view(A, :, 2:10))

            @test false == @inferred Base.mightalias(view(A, :, 2:5), view(A, :, 6:10))
            @test true == @inferred Base.mightalias(view(A, 2:5, :), view(A, :, 6:10))
            @test true == @inferred Base.mightalias(view(A, :, 2:5), view(A, 6:10, :))
            @test true == @inferred Base.mightalias(view(A, 2:5, :), view(A, 6:10, :))
        end

        @uviews A begin
            @test false == @inferred Base.mightalias(A, B)
            @test false == @inferred Base.mightalias(view(A, 2:5, :), B)
            @test false == @inferred Base.mightalias(A, view(B, :, 2:5))
            @test false == @inferred Base.mightalias(view(A, 2:5, :), view(B, :, 2:5))

            @test false == @inferred Base.mightalias(B, A)
            @test false == @inferred Base.mightalias(B, view(A, 2:5, :))
            @test false == @inferred Base.mightalias(view(B, :, 2:5), A)
            @test false == @inferred Base.mightalias(view(B, :, 2:5), view(A, 2:5, :))
        end


        @uviews A C begin
            @test false == @inferred Base.mightalias(A, C)

            @test false == @inferred Base.mightalias(view(A, 2:5, :), C)
            @test false == @inferred Base.mightalias(A, view(C, 2:5))
            @test false == @inferred Base.mightalias(view(A, 2:5, :), view(C, 2:5))
        end

        @uviews A begin
            @test false == @inferred Base.mightalias(A, C)
            @test false == @inferred Base.mightalias(view(A, 2:5, :), C)
            @test false == @inferred Base.mightalias(A, view(C, 2:5))
            @test false == @inferred Base.mightalias(view(A, 2:5, :), view(C, 2:5))

            @test false == @inferred Base.mightalias(C, A)
            @test false == @inferred Base.mightalias(C, view(A, 2:5, :))
            @test false == @inferred Base.mightalias(view(C, 2:5), A)
            @test false == @inferred Base.mightalias(view(C, 2:5), view(A, 2:5, :))
        end
    end
end

# This file is a part of UnsafeArrays.jl, licensed under the MIT License (MIT).

import Test

Test.@testset "Package UnsafeArrays" begin
    include("util.jl")
    include("unsafe_array.jl")
    include("uview.jl")
end
